from album.runner.api import setup

env_file = """channels:
  - conda-forge
  - defaults
dependencies:
  - python=3.9
  - pip
  - pip:
    - https://gitlab.com/album-app/album-client/-/archive/main/album-client-main.zip
"""


def run():
    from album.client.api import AlbumClient
    from album.runner.api import get_data_path, get_package_path

    roi1 = '100:3000:1000:3000'
    roi2 = '2000:1000:3500:2000'
    tiles = '100,200,300,400,500'
    roi = '%s,%s' % (roi1, roi2)
    output = get_data_path().joinpath('output')
    segmentation_tif = get_package_path().joinpath('data/input_mask.tif')

    args = {
        'input_raw': segmentation_tif,
        'input_mask': segmentation_tif,
        'output': output,
        'roi': roi,
        'tiles': tiles
    }

    client = AlbumClient(host='127.0.0.1', port=5555)
    client.run('de.mdc-berlin:cell-orientation:0.1.0-SNAPSHOT', args)
    client.finish_tasks()
    print("Successfully finished solution - result stored to %s." % output)


setup(
    group="de.oncoray",
    name="microglia-orientation",
    version="0.1.0-SNAPSHOT",
    title="Directional analysis of microglia",
    documentation=["documentation.md"],
    covers=[{
        "description": "Plot generated by this solution",
        "source": "cover.png"
    }],
    authors=["Sindi Nexhipi, Deborah Schmidt"],
    album_api_version="0.4.2",
    run=run,
    cite=[
        {
            "text": "Müller et al., “Slice2Volume: Fusion of multimodal medical imaging and light microscopy data of irradiation-injured brain tissue in 3D.” Rodare, Jan. 20, 2021.",
            "doi": "10.14278/rodare.915",
            "url": "https://rodare.hzdr.de/record/915"
        }
    ],
    dependencies={
        'environment_file': env_file,
        'plugins': [
            {
                'id': 'album-socket_launch-server',
                'args': {
                    'port': 5555
                }
            }
        ]
    }
)
